#!/bin/sh
# This is bash script for automation of Octave Forge packages
# ebulids writing
# (c) by Hack_leberry Finn 2012 on GPLv3 license
# Require sed, grep, ls, echo, test (and "if conditonal"), cat, cp

# Main part of ebuild auto writer
echo "$(cat ../../files/template1.ebuild && grep Title  DESCRIPTION \
| sed -e 's/Title:/DESCRIPTION=\"Octave Forge/g' -e 's/$/ package\"/g' -e \
's/\.//g' && cat ../../files/template2.ebuild && grep License: DESCRIPTION \
| sed -e 's/\.//g' -e 's/, / and /g' -e \
's/$/\"\n/g' -e 's/License: /LICENSE\=\"/g' && cat \
../../files/template3.ebuild && grep Depends: DESCRIPTION | sed  -e \
's/$/\"\n/g' -e 's/, /\n\t/g' -e 's/[()]//g' -e \
's/Depends: /DEPEND\=\"\n\t/g' -e 's/  /-/g' -e 's/ //g' -e \
's/\t/\tsci-misc\/octave-/g' -e \
's/misc\/octave-[oO]ctave/mathematics\/octave/g' | sed -e \
'/sci.*>[[:digit:]].*/{s/>/-/; s/sci/>sci/}' -e \
'/sci.*>=[[:digit:]].*/{s/>=/-/; s/sci/>=sci/}' && cat \
../../files/template4.ebuild)" > $(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))

# Checking if octave dependency is placed in DEPEND variable
Testing=$(grep "sci.*" $(echo $(ls ../*tar.gz \
| sed -e 's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' \
-e 's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e \
's/\.\.\//octave-/g' -e 's/tar\.gz/ebuild/g')) | grep "mathematics/octave")

if [ -z "$Testing"  ]
then
Testing2=$(grep "^DEPEND" $(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g')))
if [ -z "$Testing2"  ]
then
sed -i -e \
's/RDEPEND/DEPEND=\"\n\t>sci-mathematics\/octave-2\.9\.12\"\nRDEPEND/g' \
$(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))
else
sed -i -e 's/^DEPEND=\"/DEPEND=\"\n\t>sci-mathematics\/octave-2\.9\.12/g' \
$(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))
fi
else
echo "$Testing" > /dev/null
fi

# Checking extra deps (for manual correction of ebuild)
grep Suggested DESCRIPTION | sed 's/^/#/g' >> $(echo $(ls ../*tar.gz \
| sed -e 's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))
grep BuildRequires DESCRIPTION | sed 's/^/#/g' >> $(echo $(ls ../*tar.gz \
| sed -e 's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))
grep System[rR]equirements DESCRIPTION | sed 's/^/#/g' >> $(echo $(ls \
../*tar.gz | sed -e 's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' \
-e 's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))

# Guys from Octave Forge give strange dirnames so checking this
Testing=$(pwd |sed -e 's/.*octave-forge-.*\///g')
Testing2=$(ls ../*tar.gz | sed -e 's/\.\.\///g' -e 's/\.tar\.gz//g')
if [ "$Testing" != "$Testing2" ]
then
Testing2=$(ls ../*tar.gz | sed -e 's/\.\.\///g' -e 's/-[[:digit:]].*\.gz//g')
if [ "$Testing" = "$Testing2" ]
then
echo -e "\nS=\${WORKDIR}/\${PN/octave-/}" >> $(echo $(ls ../*tar.gz \
| sed -e 's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))
else
echo -e "\nS=\${WORKDIR}/$Testing" >> $(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))
fi
fi

# Avoid g-octave collision
sed -i -e 's/^RDEPEND=\"/RDEPEND=\"\!g-octave\/'$(ls ../*tar.gz | sed -e \
's/\.\.\///g' -e 's/-[[:digit:]].*$//g')'\n\t/g' $(echo $(ls ../*tar.gz \
| sed -e 's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' -e \
's/tar\.gz/ebuild/g'))

# Create main body of ebuild
cat ../../files/template5.ebuild >> $(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\//g')$(ls ../*tar.gz | sed -e 's/\.\.\//octave-/g' \
-e 's/tar\.gz/ebuild/g'))

# Create configure and Makefile as Octave pkg command do
cp ../../files/Makefile.in $(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\/files\//g'))Makefile
cp ../../files/configure.in $(echo $(ls ../*tar.gz | sed -e \
's/\.\.\//\.\.\/\.\.\/portage\/sci-misc\/octave-/g' -e \
's/-[[:digit:]].*gz$/\/files\//g'))configure
