
src_prepare() {
	cp "${FILESDIR}/Makefile"  "${S}/" || die "copying of Makefile failed"
	cp "${FILESDIR}/configure"  "${S}/" || die "copying of configure failed"
	chmod 0755 "${S}/configure"
}

src_configure() {
	econf || die "configure failed"
}

src_compile() {
	emake all || die "compile failed"
}

src_install() {
	emake DISTPKG="Gentoo emerge" DESTDIR="${D}" install || die "install failed"
}

# staff based on dist_admin script from packinfo dir generated by Makefile

pkg_postinst() {
	einfo "Update Octave internal packages cache"
	octave -H -q --no-site-file --eval "pkg('rebuild');"
}

pkg_prerm() {
	octave -H -q --no-site-file --eval "pkg('rebuild');"
	pkgdir=`octave -H -q --no-site-file --eval "l=pkg('list');disp(l{cellfun(@(x)strcmp(x.name,'"${PN/octave-/}"'),l)}.dir);"`
	rm -f $pkgdir/packinfo/on_uninstall.m
	if [ -e $pkgdir/packinfo/on_uninstall.m.orig ]; then
	 mv $pkgdir/packinfo/on_uninstall.m.orig $pkgdir/packinfo/on_uninstall.m
	 cd $pkgdir/packinfo
	 octave -q -H --no-site-file --eval "l=pkg('list');on_uninstall(l{cellfun(@(x)strcmp(x.name,'"${PN/octave-/}"'),l)});"
	fi
}

pkg_postrm() {
	einfo "Update Octave internal packages cache"
	octave -H -q --no-site-file --eval "pkg('rebuild');"
}
