#!/bin/sh
# This is main bash script for automation of Octave Forge packages
# ebulids writing
# (c) by Hack_leberry Finn 2012 on GPLv3 license
# Require wget, sed, paste, grep, chmod, ls, echo, rm, diff, date, tar, gzip,
# test (and "if conditional"), for loop, mkdir, mv

# Downloading Octave Forge latest packages listing page
wget -nv -t 10 -T 30 http://octave.sourceforge.net/packages.php

# Work was done?
if [ ! -e packages.php.old ]
then
echo "Time to do some ebuilds writing"

# Generate script for Octave Forge packages tree
echo \#\!"/bin/sh" > script1.sh
grep "class=\"package\" " packages.php | sed -e \
's/<div class\=\"package\" id=\"/mkdir -p octave-forge-/g' -e 's/\">//g' \
>> script1.sh
chmod 0755 script1.sh
./script1.sh

# Generating script for download latest packages sources
ls -d octave-forge-* |sed -e 's/^/cd /g' > helper1
grep download packages.php | sed -e \
's/<a class\=\"package_link\" href\=\"/wget -nv -t 10 -T 30 \"/g' \
-e 's/\?download\">download<\/a><\/td>/\" cd ..\//g' \
> helper2
echo \#\!"/bin/sh" > script2.sh
paste -d "\n" helper1 helper2 |sed 's/ cd /\ncd /g' >> script2.sh
chmod 0755 script2.sh
./script2.sh

# Create portage dir
mkdir -p portage/sci-misc

# Create portage Octave Forge tree
# Create dirs
sed -e 's/octave-forge/portage\/sci-misc\/octave/g' \
-e '/mkdir/{s/$/\/files/}' script1.sh >> script3.sh
chmod 0755 script3.sh
./script3.sh

# Unpack sources to get acces to Description files
grep download packages.php | sed -e \
's/<a class\=\"package_link\" href.*octave\//tar -xzf /g' \
-e 's/\?download.*$/ cd \.\.\//g' > helper3
echo \#\!"/bin/sh" > script4.sh
paste -d "\n" helper1 helper3 |sed 's/ cd /\ncd /g' >> script4.sh
chmod 0755 script4.sh
./script4.sh

# Prepare ebuild templates for manual correction
echo \#\!"/bin/sh" > script5.sh
ls octave-forge-*/*/ | grep octave-forge | sed -e 's/^/cd /g' \
-e 's/:$/\n\. \.\.\/\.\.\/ebuild\.script\.sh\ncd \.\.\/\.\.\//g' \
>> script5.sh
chmod 0755 script5.sh
./script5.sh

# Delete temporary files
rm -f helper[123] script[12345].sh
mv -f packages.php packages.php.old

else
Testing=$(diff packages.php.old packages.php)
if [ -n "$Testing" ]
then
echo "New ebuilds calling:"
Testing2=$(echo "$Testing" | grep "^>"| sed -e 's/> .*octave\///g' \
-e 's/\.tar.*$//g')
echo "$Testing2"

# Create backup of previous work
tar -czf portage.$(date +%F).tar.gz portage
tar -czf octave-forge.$(date +%F).tar.gz octave-forge-*

# Create update

echo \#\!"/bin/sh" > script1.sh
echo \#\!"/bin/sh" > script2.sh
echo \#\!"/bin/sh" > script3.sh

for Index in $(echo $Testing2 | sed -e 's/\.//g' -e 's/-[[:digit:]]*//g' -e ':a;N;$!ba;s/\n/ /g')
do

# Generating script for download latest packages sources
ls -d octave-forge-* |sed -e 's/^/cd /g' |grep "$Index" >> helper1
grep download packages.php | sed -e \
's/<a class\=\"package_link\" href\=\"/wget -nv -t 10 -T 30 \"/g' \
-e 's/\?download\">download<\/a><\/td>/\" cd ..\//g' \
| grep "$Index" >> helper2

# Unpack sources to get acces to Description files
grep download packages.php | sed -e \
's/<a class\=\"package_link\" href.*octave\//tar -xzf /g' \
-e 's/\?download.*$/ cd \.\.\//g' | grep "$Index" >> helper3

# Prepare ebuild templates for manual correction
ls octave-forge-*/*/ | grep octave-forge-"$Index" | sed -e 's/^/cd /g' \
-e 's/:$/\n\. \.\.\/\.\.\/ebuild\.script\.sh\ncd \.\.\/\.\.\//g' \
>> script3.sh

done

paste -d "\n" helper1 helper2 | sed -e 's/ cd /\ncd /g' -e\
's/wget/rm -rf \.\/\*\nwget/g' >> script1.sh
paste -d "\n" helper1 helper3 | sed -e 's/ cd /\ncd /g' >> script2.sh

chmod 0755 script1.sh
./script1.sh
chmod 0755 script2.sh
./script2.sh
chmod 0755 script3.sh
./script3.sh

# Delete temporary files
#rm -f helper[123] script[12345].sh
mv -f packages.php packages.php.old

else
echo "Nothing new on Octave Forge"
rm packages.php
fi
fi
